package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.dao.model.AnswerEntity;
import com.rf.psychological.dao.model.DimensionEntity;
import com.rf.psychological.scale.dao.model.ScaleMarksEntity;

import java.text.DecimalFormat;
import java.util.*;

/**
 * @author xbw
 * @description:竞赛失败应对量表
 * @date 2021/11/2 16:00
 */
public class CCFScale extends BaseScale{
    public CCFScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public  JSONObject scaleCalculate() throws Exception {

        //总分
        double score = 0;
        Map<String, String> resultMap0 = new LinkedHashMap<>();
        List<Map<String,String>> resultMapList = new ArrayList<>();

        //获取答案列表
        List<AnswerEntity> answerEntities = (List<AnswerEntity>) resultJson.get("answerEntities");
        //获取评分规则列表
        List<ScaleMarksEntity> scaleMarksEntities = (List<ScaleMarksEntity>) resultJson.get("scaleMarksEntities");
        //获取维度信息列表
        List<DimensionEntity> dimensionEntities = (List<DimensionEntity>) resultJson.get("dimensionEntities");
        Map<String,Double> dimensionScoreMap = new HashMap<>();
        double sum = 0;
        if (dimensionEntities.size() > 0){
            //计算每个维度得分
            double[] dimensionScore = new double[dimensionEntities.size()];
            for (int y = 0; y < dimensionEntities.size(); y++) {
                DimensionEntity dimensionEntity = dimensionEntities.get(y);
                sum = 0;
                String questionNos = dimensionEntity.getQuestionNo();
                String[] questionNo = questionNos.split("；");
                for (String question:questionNo){
                    JSONObject jsonObject1 = jsonArray.getJSONObject(Integer.parseInt(question)-1);
                    if (question.equals(jsonObject1.getString("questionNo"))){
                        for (AnswerEntity answerEntity:answerEntities){
                            if (answerEntity.getQuestionNo().equals(question) && answerEntity.getName().equals(jsonObject1.getString("checkItems"))){
                                dimensionScore[y] += Double.parseDouble(answerEntity.getScore());
                                dimensionScoreMap.put(dimensionEntity.getId(),dimensionScore[y]);
                                sum = sum + 1;
                                break;
                            }
                        }
                    }
                }
                if (sum < questionNo.length){
                    dimensionScore[y]  = dimensionScore[y] + (questionNo.length-sum)*(dimensionScore[y]/sum);
                    DecimalFormat df = new DecimalFormat("######0.00");
                    dimensionScore[y] = Double.parseDouble(df.format(dimensionScore[y]));
                }

                String dimensionSName = dimensionEntity.getName().concat("维度分");
                resultMap0.put(dimensionSName, String.valueOf(dimensionScore[y]));
                resultJson.put(dimensionSName, String.valueOf(dimensionScore[y]));
            }

            resultMapList.add(resultMap0);
            resultJson.put("dimensionScoreMap",dimensionScoreMap);
        }

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        //returnJson.put("scaleName",resultJson.getString("scaleName"));
        returnJson.put("resultJson",resultJson);

        return returnJson;
    }
}
